﻿using System;
using System.Threading.Tasks;
using Buddy.Coroutines;
using Buddy.Wildstar.BotCommon;
using Buddy.Wildstar.Game;
using Buddy.Wildstar.Game.Actors;
using GoodStalker.Controllers;
using GoodStalker.Dodge;
using GoodStalker.Extensions;


namespace GoodStalker.Behaviours
{
    /// <summary>
    ///     Provides a combat behaviour responsible for aggression.
    /// </summary>
    public class Pull : Behaviour
    {
        private readonly Actor _me;

        public Pull(SpellController spellController) : base(spellController)
        {
            _me = GameManager.LocalPlayer;
        }

        public override async Task<bool> PulseAsync()
        {
            if (!Evading.IsEvading)
            {
                if (!GameManager.LocalPlayer.HasBuff("Stealth"))
                {
                    await SpellManager.InnateAbility.Cast(_me);
                }
            }
            return true;
        }

    }
}