﻿using System;
using System.Collections.Generic;
using Buddy.Wildstar.Game;
using GoodStalker.Extensions;

namespace GoodStalker.Controllers
{
    public class SpellController
    {
        #region Fields
        private readonly List<SpellManager.SpellInformation> _stuns;
        private readonly String[] _stunList =
        {
            "Stagger",
            "Collapse",
        };

        private readonly List<SpellManager.SpellInformation> _psiBuilders;
        private readonly String[] _psiBuildersList =
        {
            "Analyze Weakness",
			"Punish",
            "Shred",
        };

        private readonly List<SpellManager.SpellInformation> _finishers;
        private readonly String[] _finishersList =
        {
            "Analyze Weakness",
            "Impale",
        };

        private readonly List<SpellManager.SpellInformation> _generalSkills;
        private readonly String[] _generalSkillsList =
        {
            "Concussive Kicks",
        };

        private readonly List<SpellManager.SpellInformation> _supportSkills;
        private readonly String[] _supportSkillsList =
        {
            "Preparation",
        };
        #endregion

        public SpellController()
        {
            this._stuns = new List<SpellManager.SpellInformation>();
            this._finishers = new List<SpellManager.SpellInformation>();
            this._generalSkills = new List<SpellManager.SpellInformation>();
            this._psiBuilders = new List<SpellManager.SpellInformation>();
            this._supportSkills = new List<SpellManager.SpellInformation>();
            this.UpdateSpells();
        }

        private void UpdateSpells()
        {
            this._stuns.Clear();
            this._stuns.Fill(this._stunList);
            this._finishers.Clear();
            this._finishers.Fill(this._finishersList);
            this._generalSkills.Clear();
            this._generalSkills.Fill(this._generalSkillsList);
            this._psiBuilders.Clear();
            this._psiBuilders.Fill(this._psiBuildersList);
            this._supportSkills.Clear();
            this._supportSkills.Fill(this._supportSkillsList);
        }

        public SpellManager.SpellInformation GetBestOffensiveSpell()
        {

            //var punish = SpellManager.GetSpell("Punish");

            //if (punish != null && punish.CooldownTimeRemaining.TotalMilliseconds > 2000)
            //{
            //    if (!GameManager.LocalPlayer.HasBuff("Concussive Kicks - Cooldown") || GameManager.LocalPlayer.HasBuff("Concussive Kicks - Cooldown") && GameManager.LocalPlayer.SuitPower >= 15)
            //    {
            //        return this._generalSkills.GetAvailableSpell();
            //    }
            //}

            var resource = GameManager.LocalPlayer.SuitPower;
            if (resource < 30)
            {
                return this._psiBuilders.GetAvailableSpell();
            }

            return resource >= 30 ? this._finishers.GetAvailableSpell() : null;
        }

        public SpellManager.SpellInformation GetBestSelfSupportSpell()
        {
            var health = GameManager.LocalPlayer.HealthPercent;
            return health < 70 ? this._supportSkills.GetAvailableSpell() : null;
        }
		
		public SpellManager.SpellInformation GetBestStun()
        {
            return this._stuns.GetAvailableSpell();
        }
    }
}